
package net.mcreator.dragonchallenge.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.HierarchicalModel;

import net.mcreator.dragonchallenge.entity.RedstonowysmokEntity;
import net.mcreator.dragonchallenge.client.model.animations.smokAnimation;
import net.mcreator.dragonchallenge.client.model.ModelCustomModel;

public class RedstonowysmokRenderer extends MobRenderer<RedstonowysmokEntity, ModelCustomModel<RedstonowysmokEntity>> {
	public RedstonowysmokRenderer(EntityRendererProvider.Context context) {
		super(context, new AnimatedModel(context.bakeLayer(ModelCustomModel.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(RedstonowysmokEntity entity) {
		return ResourceLocation.parse("dragon_challenge:textures/entities/redstonowy_smok.png");
	}

	private static final class AnimatedModel extends ModelCustomModel<RedstonowysmokEntity> {
		private final ModelPart root;
		private final HierarchicalModel animator = new HierarchicalModel<RedstonowysmokEntity>() {
			@Override
			public ModelPart root() {
				return root;
			}

			@Override
			public void setupAnim(RedstonowysmokEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
				this.root().getAllParts().forEach(ModelPart::resetPose);
				this.animateWalk(smokAnimation.fly, limbSwing, limbSwingAmount, 1f, 1f);
				this.animate(entity.animationState1, smokAnimation.atack, ageInTicks, 1f);
			}
		};

		public AnimatedModel(ModelPart root) {
			super(root);
			this.root = root;
		}

		@Override
		public void setupAnim(RedstonowysmokEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
			animator.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
			super.setupAnim(entity, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch);
		}
	}
}
